package tik_tok

import (
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"encoding/json"
	"fmt"
	"github.com/tidwall/gjson"
	"strings"
)

func DkGoodsOrder(args map[string]string) map[string]interface{} {

	params := map[string]interface{}{"time_type": args["time_type"], "size": args["size"], "cursor": args["cursor"], "start_time": args["start_time"], "end_time": args["end_time"], "distribution_type": "ProductDetail"}
	if args["distribution_type"] != "" {
		params["distribution_type"] = args["distribution_type"]
	}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.doukeOrderAds", params, args["acctoken"])
	fmt.Println(send)
	var data = map[string]interface{}{}
	if err != nil {
		return data
	}
	order := gjson.Get(send, "data.orders").String()
	data["cursor"] = gjson.Get(send, "data.cursor").String()
	var tmpList = make([]interface{}, 0)
	err = json.Unmarshal([]byte(order), &tmpList)
	if err != nil {
		return data
	}
	var orderTmp = make([]map[string]string, 0)
	statusArr := map[string]string{
		"PAY_SUCC": "订单付款",
		"REFUND":   "订单退款",
		"SETTLE":   "订单结算",
		"CONFIRM":  "订单成功",
	}
	for _, v := range tmpList {

		tmp := CommOrder(v, statusArr, "dk")
		if tmp["oid"] == "" {
			continue
		}
		orderTmp = append(orderTmp, tmp)
	}
	data["order"] = orderTmp
	return data

}

func GoodsOrder(args map[string]string) map[string]interface{} {

	params := map[string]interface{}{"time_type": args["time_type"], "size": args["size"], "cursor": args["cursor"], "start_time": args["start_time"], "end_time": args["end_time"], "distribution_type": "ProductDetail"}
	if args["distribution_type"] != "" {
		params["distribution_type"] = args["distribution_type"]
	}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.kolOrderAds", params, args["acctoken"])
	fmt.Println(send)
	var data = map[string]interface{}{}
	if err != nil {
		return data
	}
	order := gjson.Get(send, "data.orders").String()
	data["cursor"] = gjson.Get(send, "data.cursor").String()
	var tmpList = make([]interface{}, 0)
	err = json.Unmarshal([]byte(order), &tmpList)
	if err != nil {
		return data
	}
	var orderTmp = make([]map[string]string, 0)
	statusArr := map[string]string{
		"PAY_SUCC": "订单付款",
		"REFUND":   "订单退款",
		"SETTLE":   "订单结算",
		"CONFIRM":  "订单成功",
	}
	for _, v := range tmpList {
		tmp := CommOrder(v, statusArr, "")
		if tmp["oid"] == "" {
			continue
		}
		orderTmp = append(orderTmp, tmp)
	}
	data["order"] = orderTmp
	return data

}

func LiveOrder(args map[string]string) map[string]interface{} {

	params := map[string]interface{}{"size": args["size"], "cursor": args["cursor"], "start_time": args["start_time"], "end_time": args["end_time"], "distribution_type": "Live"}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.instituteOrderAds", params, args["acctoken"])
	fmt.Println(send)
	var data = map[string]interface{}{}
	if err != nil {
		return data
	}
	order := gjson.Get(send, "data.orders").String()
	data["cursor"] = gjson.Get(send, "data.cursor").String()
	var tmpList = make([]interface{}, 0)
	err = json.Unmarshal([]byte(order), &tmpList)
	if err != nil {
		return data
	}
	var orderTmp = make([]map[string]string, 0)
	statusArr := map[string]string{
		"PAY_SUCC": "订单付款",
		"REFUND":   "订单退款",
		"SETTLE":   "订单结算",
		"CONFIRM":  "订单成功",
	}
	for _, v := range tmpList {
		tmp := CommOrder(v, statusArr, "")
		if tmp["oid"] == "" {
			continue
		}
		orderTmp = append(orderTmp, tmp)
	}
	data["order"] = orderTmp
	return data

}
func CommOrder(v interface{}, statusArr map[string]string, types string) map[string]string {
	tmp := make(map[string]string)
	goods := v.(map[string]interface{})
	pidInfo, ok := goods["pid_info"].(map[string]interface{})
	mediaTypeName := ""
	if ok == false {
		return tmp
	}
	mediaTypeName = zhios_third_party_utils.AnyToString(pidInfo["media_type_name"])
	tmp = map[string]string{
		"pid":         zhios_third_party_utils.AnyToString(pidInfo["pid"]),
		"oid":         zhios_third_party_utils.AnyToString(goods["order_id"]),
		"info":        zhios_third_party_utils.AnyToString(goods["product_name"]),
		"num":         zhios_third_party_utils.AnyToString(goods["item_num"]),
		"type":        zhios_third_party_utils.AnyToString(mediaTypeName),
		"product_id":  zhios_third_party_utils.AnyToString(goods["product_id"]),
		"product_img": zhios_third_party_utils.AnyToString(goods["product_img"]),
		"payment":     zhios_third_party_utils.AnyToString(zhios_third_party_utils.AnyToFloat64(goods["total_pay_amount"]) / 100),
		"status":      statusArr[zhios_third_party_utils.AnyToString(goods["flow_point"])],
		"create_time": zhios_third_party_utils.Int64ToStr(zhios_third_party_utils.TimeStdParseUnix(zhios_third_party_utils.AnyToString(goods["pay_success_time"]))),
		"update_time": zhios_third_party_utils.Int64ToStr(zhios_third_party_utils.TimeStdParseUnix(zhios_third_party_utils.AnyToString(goods["update_time"]))),
		"refund_time": "",
		"lm_js_time":  "",
		"mid":         "",
	}
	external_info := zhios_third_party_utils.AnyToString(pidInfo["external_info"])
	tmp["is_share"] = "0"
	split := strings.Split(external_info, "_")
	if len(split) > 1 {
		if split[0] == "s" {
			tmp["is_share"] = "1"
		}
		if split[0] == "f" {
			tmp["is_share"] = "2"
		}
		tmp["uid"] = split[1]
		if len(split) == 3 {
			tmp["mid"] = split[2]
		}
	}
	if tmp["type"] == "Live" || tmp["type"] == "Activity" || tmp["type"] == "Mix" || types == "dk" {
		tmp["commission"] = zhios_third_party_utils.AnyToString(zhios_third_party_utils.AnyToFloat64(goods["ads_estimated_commission"]) / 100)
		if zhios_third_party_utils.AnyToFloat64(goods["ads_real_commission"]) > 0 {
			tmp["commission"] = zhios_third_party_utils.AnyToString(zhios_third_party_utils.AnyToFloat64(goods["ads_real_commission"]) / 100)
		}
	}
	if tmp["type"] == "ProductDetail" && types == "" {
		tmp["commission"] = zhios_third_party_utils.AnyToString(zhios_third_party_utils.AnyToFloat64(goods["estimated_commission"]) / 100)
		if zhios_third_party_utils.AnyToFloat64(goods["real_commission"]) > 0 {
			tmp["commission"] = zhios_third_party_utils.AnyToString(zhios_third_party_utils.AnyToFloat64(goods["real_commission"]) / 100)
		}
	}
	if zhios_third_party_utils.AnyToString(goods["refund_time"]) != "" {
		tmp["refund_time"] = zhios_third_party_utils.Int64ToStr(zhios_third_party_utils.TimeStdParseUnix(zhios_third_party_utils.AnyToString(goods["pay_success_time"])))
	}
	if zhios_third_party_utils.AnyToString(goods["settle_time"]) != "" {
		tmp["lm_js_time"] = zhios_third_party_utils.Int64ToStr(zhios_third_party_utils.TimeStdParseUnix(zhios_third_party_utils.AnyToString(goods["settle_time"])))
	}
	return tmp
}
